#!/usr/bin/perl -w

use lib "./blib/lib"; 
use lib "./blib/arch"; 

use Data::Array2ArrayMap::SDB;

my $filename= shift @ARGV;
$filename||='./proba.sdb';

my $sdb;
eval {
    $sdb = new Data::Array2ArrayMap::SDB($filename);
};
if ($@) {
    die "Error to open $filename: $@";
}

while(1) {
    print "Command: "; my $c = <>; chomp $c;
    if($c eq "g" || $c eq "get" ||
       $c eq "f" || $c eq "find" ||
       $c eq "t" || $c eq "type" ||
       $c eq "fp" || $c eq "find_pair") {
    } elsif($c eq "e" || $c eq "end") {
	last;
    } else {
	print STDERR "Command [$c] is not supported.
avaliable commands: 
g -> get
f -> find
t -> type
fp-> find_pair
e -> end
\n";
	next;
    }

    print "Noids, value: "; my $n = <>; chomp $n;
    my @ns = split(/\s*,\s*/, $n);
    if (@ns<1) {
	print STDERR "Bad path !\n";
	next;
    }

    my $str;
    if($c eq "g" || $c eq "get") {
	$str = $sdb -> get_ref([@ns]);
    } elsif($c eq "f" || $c eq "find") {
	$str = $sdb -> find_ref([@ns]);
    } elsif($c eq "t" || $c eq "type") {
	$str = [$sdb -> type([@ns])];
    } elsif($c eq "fp" || $c eq "find_pair") {
	print "Search by prefix [N/y]? "; my $pr = <>; chomp $pr;
	if($pr eq "y" || $pr eq "Y") {
	    $sdb->set_str_pref();
	} else {
	    $sdb->set_str_full();
	}
	$str = $sdb -> find_pair([@ns]);
    } 
    print "V: ", join(', ', @$str), "\n";
}

